# skybox.mod

param nPhoto integer, > 0;
set Rel within {1..nPhoto, 1..nPhoto};
param alpha > 0;
param k integer, > 0;
param pts{1..k, 1..2};
param Hpts{Rel, 1..k, 1..2};
var R{1..nPhoto, 1..3, 1..3};
var absx{Rel, 1..k} >= 0;
var absy{Rel, 1..k} >= 0;
var HRptsx{Rel, 1..k};
var HRptsy{Rel, 1..k};
var HRptsz{Rel, 1..k};
var HRptsxx{Rel, 1..k};
var HRptsyy{Rel, 1..k};

minimize error: sum{(i, j) in Rel, ik in 1..k} (absx[i,j,ik] + absy[i,j,ik]);

subject to first_rotation_diag{i in 1..3, j in 1..3: i = j}: R[1,i,j] = 1;
subject to first_rotation_nondiag{i in 1..3, j in 1..3: i != j}: R[1,i,j] = 0;
subject to rotation_diag{p in 1..nPhoto, i in 1..3, j in 1..3: i = j}: R[p,i,1] * R[p,j,1] + R[p,i,2] * R[p,j,2] + R[p,i,3] * R[p,j,3] = 1;
subject to rotation_nondiag{p in 1..nPhoto, i in 1..3, j in 1..3: i > j}: R[p,i,1] * R[p,j,1] + R[p,i,2] * R[p,j,2] + R[p,i,3] * R[p,j,3] = 0;
subject to multip_HRptsx{(i, j) in Rel, ik in 1..k}: HRptsx[i,j,ik] = (R[j,1,1] * R[i,1,1] + R[j,2,1] * R[i,2,1] + R[j,3,1] * R[i,3,1]) * pts[ik,1] + (R[j,1,1] * R[i,1,2] + R[j,2,1] * R[i,2,2] + R[j,3,1] * R[i,3,2]) * pts[ik,2] + (R[j,1,1] * R[i,1,3] + R[j,2,1] * R[i,2,3] + R[j,3,1] * R[i,3,3]) * alpha;
subject to multip_HRptsy{(i, j) in Rel, ik in 1..k}: HRptsy[i,j,ik] = (R[j,1,2] * R[i,1,1] + R[j,2,2] * R[i,2,1] + R[j,3,2] * R[i,3,1]) * pts[ik,1] + (R[j,1,2] * R[i,1,2] + R[j,2,2] * R[i,2,2] + R[j,3,2] * R[i,3,2]) * pts[ik,2] + (R[j,1,2] * R[i,1,3] + R[j,2,2] * R[i,2,3] + R[j,3,2] * R[i,3,3]) * alpha;
subject to multip_HRptsz{(i, j) in Rel, ik in 1..k}: HRptsz[i,j,ik] = (R[j,1,3] * R[i,1,1] + R[j,2,3] * R[i,2,1] + R[j,3,3] * R[i,3,1]) * pts[ik,1] / alpha + (R[j,1,3] * R[i,1,2] + R[j,2,3] * R[i,2,2] + R[j,3,3] * R[i,3,2]) * pts[ik,2] / alpha + (R[j,1,3] * R[i,1,3] + R[j,2,3] * R[i,2,3] + R[j,3,3] * R[i,3,3]);
subject to homogene_HRptsxx{(i, j) in Rel, ik in 1..k}: HRptsxx[i,j,ik] * HRptsz[i,j,ik] = HRptsx[i,j,ik];
subject to homogene_HRptsyy{(i, j) in Rel, ik in 1..k}: HRptsyy[i,j,ik] * HRptsz[i,j,ik] = HRptsy[i,j,ik];
subject to absx1{(i, j) in Rel, ik in 1..k}: absx[i,j,ik] >= HRptsx[i,j,ik] - Hpts[i,j,ik,1];
subject to absx2{(i, j) in Rel, ik in 1..k}: absx[i,j,ik] >= Hpts[i,j,ik,1] - HRptsx[i,j,ik];
subject to absy1{(i, j) in Rel, ik in 1..k}: absy[i,j,ik] >= HRptsy[i,j,ik] - Hpts[i,j,ik,2];
subject to absy2{(i, j) in Rel, ik in 1..k}: absy[i,j,ik] >= Hpts[i,j,ik,2] - HRptsy[i,j,ik];

# var A{M,N};
# var B{N,P};

# for matprod{i in M, p in P}: sum{j in N} A[i,j]*B[j,p];
